#include <iostream>

#include "i3d/image3d.h"
#include "labelling.h"

using namespace std;
using namespace i3d;


void FloodFill( Image3d<GRAY8> &img,
		const int x,const int y,const int z,
		const GRAY8 col)
{
	//kolikrat tato funkce malovala
	static int pocitadlo=0;

	//kontrola, ze zadany pixel je uvnitr obrazu
	if (! img.Include(x,y,z) ) return;

	//a pokud je, zjistuje se jeho hodnota
	if (img.GetVoxel(x,y,z) == 1)
	{
		//je to prvek nejake neobarvene komponenty, obarvime
		img.SetVoxel(x,y,z,col);

		//zvednout pocitadlo a pri vyroci ulozit vysledek na disk
		++pocitadlo;
		if ((pocitadlo % 1000) == -1) //-1 to prakticky vypne
		{
			char fn[50];
			sprintf(fn,"mezivysledek%03d.bmp",pocitadlo/1000);
			img.SaveImageBMP(fn);
		}

		//6-sousedstvi ve 3D
		FloodFill(img,x-1,y,z,col);
		FloodFill(img,x+1,y,z,col);
		FloodFill(img,x,y-1,z,col);
		FloodFill(img,x,y+1,z,col);
		FloodFill(img,x,y,z-1,col);
		FloodFill(img,x,y,z+1,col);
	}
}


GRAY8 LabelImage(Image3d<GRAY8> &img)
{
	//obarvovani komponent barvami od 10 nahoru
	cout << "Doing flooding.\n";
	GRAY8 barva=9;

	for (size_t i=0; i < img.GetImageSize(); ++i)
	{
		if (img.GetVoxel(i) == 1)
		{
			/*
			cout << "Narazil jsem do komponenty na pozici "
				<< img.GetPos(i)
				<< ", budu barvit hodnotou "
				<< barva+1 << "\n";
			 */

			FloodFill(img,
				img.GetX(i),
				img.GetY(i),
				img.GetZ(i),
				++barva);
		}
	}

	return(barva-9);
}

