#include "mylist.h"
#include <stdlib.h>

int AddToHistogram(struct Elem** h,
							const int val)
{

	int counter=0;

	if (*h == NULL)
	{
		//zalozeni uplne prvniho prvku v histogramu
		*h=new struct Elem;
		(*h)->intensity=val;
		(*h)->count=1;
		(*h)->next=NULL;
		(*h)->prev=NULL;
		//std::cout << "zakladam uplne prvni prvek\n";
		return(0);
	}

	//hledani mista, kam vlozit prvek do seznamu
	struct Elem* tmp=*h;
	struct Elem* tmpB=*h;
	while ((tmp) && (tmp->intensity < val))
	{
		tmpB=tmp;
		tmp=tmp->next;
		++counter;
	}

	if (!tmp)
	{
		//v histogramu neni pridavana hodnota, jsme na jeho konci
		tmp=new struct Elem;
		tmp->intensity=val;
		tmp->count=1;
		tmp->next=NULL;
		tmp->prev=tmpB;
		tmpB->next=tmp;
		//std::cout << "pridavam novy prvek uplne na konec\n";
	}
	else if (tmp->intensity == val)
	{
		//v histogramu je pridavana hodnota
		tmp->count += 1;
	}
	else
	{
		//v histogramu neni pridavana hodnota, jsme nekde uvnitr seznamu
		tmpB=new struct Elem;
		tmpB->intensity=val;
		tmpB->count=1;
		tmpB->next=tmp;
		tmpB->prev=tmp->prev;

		if (tmp->prev) (tmp->prev)->next=tmpB;
		else (*h)=tmpB;

		tmp->prev=tmpB;
	}
/*
h -> *h -> **h = struct

A B C  .   tmp D E
      tmpB
*/
	return(counter);
}


int AddToHistogram(struct Elem** h,
							struct Elem** p,
							const int val)
{

	int counter=0;

	if (*h == NULL)
	{
		//zalozeni uplne prvniho prvku v histogramu
		*h=new struct Elem;
		(*h)->intensity=val;
		(*h)->count=1;
		(*h)->next=NULL;
		(*h)->prev=NULL;
		//std::cout << "zakladam uplne prvni prvek\n";
		*p=*h;
		return(0);
	}

	//hledani mista, kam vlozit prvek do seznamu
	struct Elem* tmp=*h;
	struct Elem* tmpB=*h;
	char moveNext=1; //mame se v seznamu pohybovat doprava (=1) nebo doleva (=0)

	//pokud mame info, kde jsme skoncili posledne,
	//zacneme od tam
	if (*p != NULL)
	{
		tmp=tmpB=*p;
		if (val < (*p)->intensity) moveNext=0;
	}

	//kterym smerem se vydat?
	if (moveNext)
	{
		//hledame v seznamu smerem k vyssim hodnotam
		while ((tmp) && (tmp->intensity < val))
		{
			tmpB=tmp;
			tmp=tmp->next;
			++counter;
		}

		if (!tmp)
		{
			//v histogramu neni pridavana hodnota, jsme na jeho konci
			tmp=new struct Elem;
			tmp->intensity=val;
			tmp->count=1;
			tmp->next=NULL;
			tmp->prev=tmpB;
			tmpB->next=tmp;
			//std::cout << "pridavam novy prvek uplne na konec\n";
			*p=tmp;
		}
		else if (tmp->intensity == val)
		{
			//v histogramu je pridavana hodnota
			tmp->count += 1;
			*p=tmp;
		}
		else
		{
			//v histogramu neni pridavana hodnota, jsme nekde uvnitr seznamu
			tmpB=new struct Elem;
			tmpB->intensity=val;
			tmpB->count=1;
			tmpB->next=tmp;
			tmpB->prev=tmp->prev;

			if (tmp->prev) (tmp->prev)->next=tmpB;
			else (*h)=tmpB;

			tmp->prev=tmpB;
			*p=tmpB;
		}

	}
	else // if (moveNext)
	{

		//hledame v seznamu smerem k nizsim hodnotam
		while ((tmp) && (tmp->intensity > val))
		{
			tmpB=tmp;
			tmp=tmp->prev;
			++counter;
		}

		if (!tmp)
		{
			//v histogramu neni pridavana hodnota, jsme na jeho zacatku
			tmp=new struct Elem;
			tmp->intensity=val;
			tmp->count=1;
			tmp->next=tmpB;
			tmp->prev=NULL;
			tmpB->prev=tmp; //note: tmpB == *h
			(*h)=tmp;
			//std::cout << "pridavam novy prvek uplne na zacatek\n";
			*p=tmp;
		}
		else if (tmp->intensity == val)
		{
			//v histogramu je pridavana hodnota
			tmp->count += 1;
			*p=tmp;
		}
		else
		{
			//v histogramu neni pridavana hodnota, jsme nekde uvnitr seznamu
			tmpB=new struct Elem;
			tmpB->intensity=val;
			tmpB->count=1;
			tmpB->prev=tmp;
			tmpB->next=tmp->next;

			if (tmp->next) (tmp->next)->prev=tmpB;

			tmp->next=tmpB;
			*p=tmpB;
		}

	} // if (moveNext)

	return(counter);
}
